BeanFactory (Spring Framework 3.2.1.RELEASE API)
Date: 2013-01-24

org.springframework.beans.factory

## Interface BeanFactory

- All Known Subinterfaces:
    ApplicationContext, AutowireCapableBeanFactory, ConfigurableApplicationContext, ConfigurableBeanFactory, ConfigurableListableBeanFactory, ConfigurablePortletApplicationContext, ConfigurableWebApplicationContext, HierarchicalBeanFactory, ListableBeanFactory, WebApplicationContext
  All Known Implementing Classes:
    AbstractApplicationContext, AbstractAutowireCapableBeanFactory, AbstractBeanFactory, AbstractRefreshableApplicationContext, AbstractRefreshableConfigApplicationContext, AbstractRefreshablePortletApplicationContext, AbstractRefreshableWebApplicationContext, AbstractXmlApplicationContext, AnnotationConfigApplicationContext, AnnotationConfigWebApplicationContext, ClassPathXmlApplicationContext, DefaultListableBeanFactory, FileSystemXmlApplicationContext, GenericApplicationContext, GenericWebApplicationContext, GenericXmlApplicationContext, ResourceAdapterApplicationContext, SimpleJndiBeanFactory, StaticApplicationContext, StaticListableBeanFactory, StaticPortletApplicationContext, StaticWebApplicationContext, XmlBeanFactory, XmlPortletApplicationContext, XmlWebApplicationContext

      public interface BeanFactory

  The root interface for accessing a Spring bean container. This is the basic client view of a bean container; further interfaces such as `ListableBeanFactory` and `ConfigurableBeanFactory` are available for specific purposes.

  This interface is implemented by objects that hold a number of bean definitions, each uniquely identified by a String name. Depending on the bean definition, the factory will return either an independent instance of a contained object (the Prototype design pattern), or a single shared instance (a superior alternative to the Singleton design pattern, in which the instance is a singleton in the scope of the factory). Which type of instance will be returned depends on the bean factory configuration: the API is the same. Since Spring 2.0, further scopes are available depending on the concrete application context (e.g. "request" and "session" scopes in a web environment).

  The point of this approach is that the BeanFactory is a central registry of application components, and centralizes configuration of application components (no more do individual objects need to read properties files, for example). See chapters 4 and 11 of "Expert One-on-One J2EE Design and Development" for a discussion of the benefits of this approach.

  Note that it is generally better to rely on Dependency Injection ("push" configuration) to configure application objects through setters or constructors, rather than use any form of "pull" configuration like a BeanFactory lookup. Spring's Dependency Injection functionality is implemented using this BeanFactory interface and its subinterfaces.

  Normally a BeanFactory will load bean definitions stored in a configuration source (such as an XML document), and use the `org.springframework.beans` package to configure the beans. However, an implementation could simply return Java objects it creates as necessary directly in Java code. There are no constraints on how the definitions could be stored: LDAP, RDBMS, XML, properties file, etc. Implementations are encouraged to support references amongst beans (Dependency Injection).

  In contrast to the methods in `ListableBeanFactory`, all of the operations in this interface will also check parent factories if this is a `HierarchicalBeanFactory`. If a bean is not found in this factory instance, the immediate parent factory will be asked. Beans in this factory instance are supposed to override beans of the same name in any parent factory.

  Bean factory implementations should support the standard bean lifecycle interfaces as far as possible. The full set of initialization methods and their standard order is:
  1. BeanNameAware's `setBeanName`
  2. BeanClassLoaderAware's `setBeanClassLoader`
  3. BeanFactoryAware's `setBeanFactory`
  4. ResourceLoaderAware's `setResourceLoader` (only applicable when running in an application context)
  5. ApplicationEventPublisherAware's `setApplicationEventPublisher` (only applicable when running in an application context)
  6. MessageSourceAware's `setMessageSource` (only applicable when running in an application context)
  7. ApplicationContextAware's `setApplicationContext` (only applicable when running in an application context)
  8. ServletContextAware's `setServletContext` (only applicable when running in a web application context)
  9. `postProcessBeforeInitialization` methods of BeanPostProcessors
  10. InitializingBean's `afterPropertiesSet`
  11. a custom init-method definition
  12. `postProcessAfterInitialization` methods of BeanPostProcessors

  On shutdown of a bean factory, the following lifecycle methods apply:
  1. DisposableBean's `destroy`
  2. a custom destroy-method definition

  Since:
    13 April 2001
  Author:
    Rod Johnson, Juergen Hoeller, Chris Beams
  See Also:
    `BeanNameAware.setBeanName(java.lang.String)`, `BeanClassLoaderAware.setBeanClassLoader(java.lang.ClassLoader)`, `BeanFactoryAware.setBeanFactory(org.springframework.beans.factory.BeanFactory)`, `ResourceLoaderAware.setResourceLoader(org.springframework.core.io.ResourceLoader)`, `ApplicationEventPublisherAware.setApplicationEventPublisher(org.springframework.context.ApplicationEventPublisher)`, `MessageSourceAware.setMessageSource(org.springframework.context.MessageSource)`, `ApplicationContextAware.setApplicationContext(org.springframework.context.ApplicationContext)`, `ServletContextAware.setServletContext(javax.servlet.ServletContext)`, `BeanPostProcessor.postProcessBeforeInitialization(java.lang.Object, java.lang.String)`, `InitializingBean.afterPropertiesSet()`, `AbstractBeanDefinition.getInitMethodName()`, `BeanPostProcessor.postProcessAfterInitialization(java.lang.Object, java.lang.String)`, `DisposableBean.destroy()`, `AbstractBeanDefinition.getDestroyMethodName()`

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static String` | `FACTORY_BEAN_PREFIX` Used to dereference a `FactoryBean` instance and distinguish it from beans created by the FactoryBean.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `containsBean(String name)` Does this bean factory contain a bean definition or externally registered singleton instance with the given name?
    `String[]` | `getAliases(String name)` Return the aliases for the given bean name, if any.
    `<T> T` | `getBean(Class<T> requiredType)` Return the bean instance that uniquely matches the given object type, if any.
    `Object` | `getBean(String name)` Return an instance, which may be shared or independent, of the specified bean.
    `<T> T` | `getBean(String name, Class<T> requiredType)` Return an instance, which may be shared or independent, of the specified bean.
    `Object` | `getBean(String name, Object... args)` Return an instance, which may be shared or independent, of the specified bean.
    `Class<?>` | `getType(String name)` Determine the type of the bean with the given name.
    `boolean` | `isPrototype(String name)` Is this bean a prototype? That is, will `getBean(java.lang.String)` always return independent instances?
    `boolean` | `isSingleton(String name)` Is this bean a shared singleton? That is, will `getBean(java.lang.String)` always return the same instance?
    `boolean` | `isTypeMatch(String name, Class<?> targetType)` Check whether the bean with the given name matches the specified type.

- - ### Field Detail

    - #### FACTORY_BEAN_PREFIX

          static final String FACTORY_BEAN_PREFIX

      Used to dereference a `FactoryBean` instance and distinguish it from beans created by the FactoryBean. For example, if the bean named `myJndiObject` is a FactoryBean, getting `&myJndiObject` will return the factory, not the instance returned by the factory.
      See Also:
        Constant Field Values

  - ### Method Detail

    - #### getBean

          Object getBean(String name)
                         throws BeansException

      Return an instance, which may be shared or independent, of the specified bean.

      This method allows a Spring BeanFactory to be used as a replacement for the Singleton or Prototype design pattern. Callers may retain references to returned objects in the case of Singleton beans.

      Translates aliases back to the corresponding canonical bean name. Will ask the parent factory if the bean cannot be found in this factory instance.

      Parameters:
        `name` - the name of the bean to retrieve
      Returns:
        an instance of the bean
      Throws:
        `NoSuchBeanDefinitionException` - if there is no bean definition with the specified name
        `BeansException` - if the bean could not be obtained

    - #### getBean

          <T> T getBean(String name,
                      Class<T> requiredType)
                    throws BeansException

      Return an instance, which may be shared or independent, of the specified bean.

      Behaves the same as `getBean(String)`, but provides a measure of type safety by throwing a BeanNotOfRequiredTypeException if the bean is not of the required type. This means that ClassCastException can't be thrown on casting the result correctly, as can happen with `getBean(String)`.

      Translates aliases back to the corresponding canonical bean name. Will ask the parent factory if the bean cannot be found in this factory instance.

      Parameters:
        `name` - the name of the bean to retrieve
        `requiredType` - type the bean must match. Can be an interface or superclass of the actual class, or `null` for any match. For example, if the value is `Object.class`, this method will succeed whatever the class of the returned instance.
      Returns:
        an instance of the bean
      Throws:
        `NoSuchBeanDefinitionException` - if there is no such bean definition
        `BeanNotOfRequiredTypeException` - if the bean is not of the required type
        `BeansException` - if the bean could not be created

    - #### getBean

          <T> T getBean(Class<T> requiredType)
                    throws BeansException

      Return the bean instance that uniquely matches the given object type, if any.
      Parameters:
        `requiredType` - type the bean must match; can be an interface or superclass. `null` is disallowed.

        This method goes into `ListableBeanFactory` by-type lookup territory but may also be translated into a conventional by-name lookup based on the name of the given type. For more extensive retrieval operations across sets of beans, use `ListableBeanFactory` and/or `BeanFactoryUtils`.

      Returns:
        an instance of the single bean matching the required type
      Throws:
        `NoSuchBeanDefinitionException` - if no bean of the given type was found
        `NoUniqueBeanDefinitionException` - if more than one bean of the given type was found
        `BeansException`
      Since:
        3.0
      See Also:
        `ListableBeanFactory`

    - #### getBean

          Object getBean(String name,
                       Object... args)
                         throws BeansException

      Return an instance, which may be shared or independent, of the specified bean.

      Allows for specifying explicit constructor arguments / factory method arguments, overriding the specified default arguments (if any) in the bean definition.

      Parameters:
        `name` - the name of the bean to retrieve
        `args` - arguments to use if creating a prototype using explicit arguments to a static factory method. It is invalid to use a non-null args value in any other case.
      Returns:
        an instance of the bean
      Throws:
        `NoSuchBeanDefinitionException` - if there is no such bean definition
        `BeanDefinitionStoreException` - if arguments have been given but the affected bean isn't a prototype
        `BeansException` - if the bean could not be created
      Since:
        2.5

    - #### containsBean

          boolean containsBean(String name)

      Does this bean factory contain a bean definition or externally registered singleton instance with the given name?

      If the given name is an alias, it will be translated back to the corresponding canonical bean name.

      If this factory is hierarchical, will ask any parent factory if the bean cannot be found in this factory instance.

      If a bean definition or singleton instance matching the given name is found, this method will return `true` whether the named bean definition is concrete or abstract, lazy or eager, in scope or not. Therefore, note that a `true` return value from this method does not necessarily indicate that `getBean(java.lang.String)` will be able to obtain an instance for the same name.

      Parameters:
        `name` - the name of the bean to query
      Returns:
        whether a bean with the given name is present

    - #### isSingleton

          boolean isSingleton(String name)
                              throws NoSuchBeanDefinitionException

      Is this bean a shared singleton? That is, will `getBean(java.lang.String)` always return the same instance?

      Note: This method returning `false` does not clearly indicate independent instances. It indicates non-singleton instances, which may correspond to a scoped bean as well. Use the `isPrototype(java.lang.String)` operation to explicitly check for independent instances.

      Translates aliases back to the corresponding canonical bean name. Will ask the parent factory if the bean cannot be found in this factory instance.

      Parameters:
        `name` - the name of the bean to query
      Returns:
        whether this bean corresponds to a singleton instance
      Throws:
        `NoSuchBeanDefinitionException` - if there is no bean with the given name
      See Also:
        `getBean(java.lang.String)`, `isPrototype(java.lang.String)`

    - #### isPrototype

          boolean isPrototype(String name)
                              throws NoSuchBeanDefinitionException

      Is this bean a prototype? That is, will `getBean(java.lang.String)` always return independent instances?

      Note: This method returning `false` does not clearly indicate a singleton object. It indicates non-independent instances, which may correspond to a scoped bean as well. Use the `isSingleton(java.lang.String)` operation to explicitly check for a shared singleton instance.

      Translates aliases back to the corresponding canonical bean name. Will ask the parent factory if the bean cannot be found in this factory instance.

      Parameters:
        `name` - the name of the bean to query
      Returns:
        whether this bean will always deliver independent instances
      Throws:
        `NoSuchBeanDefinitionException` - if there is no bean with the given name
      Since:
        2.0.3
      See Also:
        `getBean(java.lang.String)`, `isSingleton(java.lang.String)`

    - #### isTypeMatch

          boolean isTypeMatch(String name,
                            Class<?> targetType)
                              throws NoSuchBeanDefinitionException

      Check whether the bean with the given name matches the specified type. More specifically, check whether a `getBean(java.lang.String)` call for the given name would return an object that is assignable to the specified target type.

      Translates aliases back to the corresponding canonical bean name. Will ask the parent factory if the bean cannot be found in this factory instance.

      Parameters:
        `name` - the name of the bean to query
        `targetType` - the type to match against
      Returns:
        `true` if the bean type matches, `false` if it doesn't match or cannot be determined yet
      Throws:
        `NoSuchBeanDefinitionException` - if there is no bean with the given name
      Since:
        2.0.1
      See Also:
        `getBean(java.lang.String)`, `getType(java.lang.String)`

    - #### getType

          Class<?> getType(String name)
                           throws NoSuchBeanDefinitionException

      Determine the type of the bean with the given name. More specifically, determine the type of object that `getBean(java.lang.String)` would return for the given name.

      For a `FactoryBean`, return the type of object that the FactoryBean creates, as exposed by `FactoryBean.getObjectType()`.

      Translates aliases back to the corresponding canonical bean name. Will ask the parent factory if the bean cannot be found in this factory instance.

      Parameters:
        `name` - the name of the bean to query
      Returns:
        the type of the bean, or `null` if not determinable
      Throws:
        `NoSuchBeanDefinitionException` - if there is no bean with the given name
      Since:
        1.1.2
      See Also:
        `getBean(java.lang.String)`, `isTypeMatch(java.lang.String, java.lang.Class<?>)`

    - #### getAliases

          String[] getAliases(String name)

      Return the aliases for the given bean name, if any. All of those aliases point to the same bean when used in a `getBean(java.lang.String)` call.

      If the given name is an alias, the corresponding original bean name and other aliases (if any) will be returned, with the original bean name being the first element in the array.

      Will ask the parent factory if the bean cannot be found in this factory instance.

      Parameters:
        `name` - the bean name to check for aliases
      Returns:
        the aliases, or an empty array if none
      See Also:
        `getBean(java.lang.String)`